con

  GP_RIGHT  = %00000001
  GP_LEFT   = %00000010
  GP_DOWN   = %00000100
  GP_UP     = %00001000
  GP_START  = %00010000
  GP_SELECT = %00100000
  GP_B      = %01000000
  GP_A      = %10000000
        
var

  long stack[6]
  long nes_bits

pub start(keyboard_pin, keyboard_enable)
 'this is for compatability only, no keyboard routines in here

  nes_bits := 0

  'cognew(process, @stack)

pub read

  'return nes_bits
  return process

PUB button(nes_button) | g_nes_bits
'' Return TRUE/FALSE if sent button is down
  g_nes_bits:=Read
  return(nes_button & g_nes_bits)

pub process | i, bits

  ' set I/O ports to proper direction
  ' P3 = JOY_CLK    (4)
  ' P4 = JOY_SH/LDn (5) 
  ' P5 = JOY_DATAOUT0 (6)
  ' P6 = JOY_DATAOUT1 (7)
  ' NES Bit Encoding

  DIRA [1] := 1 ' output
  DIRA [0] := 1 ' output
  OUTA [1] := 1 ' +5
  OUTA [0] := 0 ' gnd

  DIRA [4] := 1 ' output
  DIRA [5] := 1 ' output
  DIRA [2] := 0 ' input
  DIRA [3] := 0 ' input

  OUTA [5] := 0 ' JOY_CLK = 0
  OUTA [4] := 0 ' JOY_SH/LDn = 0
  OUTA [4] := 1 ' JOY_SH/LDn = 1
  OUTA [4] := 0 ' JOY_SH/LDn = 0
  nes_bits := 0
  nes_bits := INA[3] | (INA[2] << 8)

  repeat i from 0 to 6
    OUTA [5] := 1 ' JOY_CLK = 1
    OUTA [5] := 0 ' JOY_CLK = 0
    nes_bits := (nes_bits << 1)
    nes_bits := nes_bits | INA[3] | (INA[2] << 8)

  nes_bits := (!nes_bits & $FFFF)

    return nes_bits
        